package com.szpg.db.dao.impl;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

import org.apache.commons.dbutils.DbUtils;
import org.apache.commons.dbutils.QueryRunner;
import org.apache.commons.dbutils.handlers.ArrayListHandler;
import org.apache.log4j.Logger;

import com.szpg.db.dao.PgCODao;
import com.szpg.db.data.PgCO;
import com.szpg.db.data.PgCOAlm;
import com.szpg.db.util.ConnectionManager;
import com.szpg.util.NumberFormat;

public class PgCODaoImpl implements PgCODao {
	
	private final Logger logger = Logger.getLogger(this.getClass().getName());

	@Override
	public List<PgCO> findAllPblz() {
		Connection conn = null;
		
		String queryStr = "SELECT ID, CO, LOGTIME, PGDEVICEID FROM PG_CO";
		try {
			conn = ConnectionManager.getConnectionFromC3P0();
			conn.setAutoCommit(false);
			
			QueryRunner runner = new QueryRunner();
			List<Object[]> tempList = (List<Object[]>) runner.query(conn, queryStr, new ArrayListHandler());
			
			if (null != tempList && tempList.isEmpty() == false) {
				logger.debug("查询所有一氧化碳监测值成功[" + tempList.size() + "]");
				
				List<PgCO> list = new ArrayList<PgCO>();
				for (int i = 0; i < tempList.size(); i++) {
					PgCO co = new PgCO();
					Object[] item = tempList.get(i);
					
					co.setId(((Number) item[0]).intValue());
					co.setCo(Float.parseFloat((String) item[1]));
					co.setPgdeviceid(((Number) item[3]).intValue());
					
					long tmValue = ((java.sql.Timestamp) ((oracle.sql.TIMESTAMP) item[2]).toJdbc()).getTime();
					Calendar cal = Calendar.getInstance();
					cal.setTimeInMillis(tmValue);
					co.setLogtime(cal.getTime());
					co.setUptime(cal.getTime());
					
					list.add(co);
				}
				return list;
			}
			else 
				return null;
		} catch (Exception ex) {
			logger.error("查询所有一氧化碳监测值异常", ex);
		} finally {
			try {
				DbUtils.commitAndClose(conn);
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		return null;
	}

	@Override
	public PgCO findPblzById(Integer id) {
		Connection conn = null;
		
		String queryStr = "SELECT ID, CO, LOGTIME, PGDEVICEID FROM PG_CO WHERE ID = ?";
		Object[] param = new Object[1];
		param[0] = id;
		try {
			conn = ConnectionManager.getConnectionFromC3P0();
			conn.setAutoCommit(false);
			
			QueryRunner runner = new QueryRunner();
			List<Object[]> tempList = (List<Object[]>) runner.query(conn, queryStr, new ArrayListHandler(), param);
			
			if (null != tempList && tempList.size() == 1) {
				PgCO co = new PgCO();
				Object[] item = tempList.get(0);
				
				co.setId(((Number) item[0]).intValue());
				co.setCo(Float.parseFloat((String) item[1]));
				co.setPgdeviceid(((Number) item[3]).intValue());
				
				long tmValue = ((java.sql.Timestamp) ((oracle.sql.TIMESTAMP) item[2]).toJdbc()).getTime();
				Calendar cal = Calendar.getInstance();
				cal.setTimeInMillis(tmValue);
				co.setLogtime(cal.getTime());
				co.setUptime(cal.getTime());
				
				logger.debug("根据ID查询一氧化碳监测值成功" + co + "]");
				
				return co;
			}
			else 
				return null;
		} catch (Exception ex) {
			logger.error("根据ID查询一氧化碳监测值异常", ex);
		} finally {
			try {
				DbUtils.commitAndClose(conn);
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		return null;
	}

	@Override
	public List<PgCO> findPblzByDevice(Integer deviceid) {
		Connection conn = null;
		
		String queryStr = "SELECT ID, CO, LOGTIME, PGDEVICEID FROM PG_CO WHERE PGDEVICEID = ?";
		Object[] param = new Object[1];
		param[0] = deviceid;
		try {
			conn = ConnectionManager.getConnectionFromC3P0();
			conn.setAutoCommit(false);
			
			QueryRunner runner = new QueryRunner();
			List<Object[]> tempList = (List<Object[]>) runner.query(conn, queryStr, new ArrayListHandler());
			
			if (null != tempList && tempList.isEmpty() == false) {
				logger.debug("根据设备ID查询一氧化碳监测值成功[" + tempList.size() + "]");
				
				List<PgCO> list = new ArrayList<PgCO>();
				for (int i = 0; i < tempList.size(); i++) {
					PgCO co = new PgCO();
					Object[] item = tempList.get(i);
					
					co.setId(((Number) item[0]).intValue());
					co.setCo(Float.parseFloat((String) item[1]));
					co.setPgdeviceid(((Number) item[3]).intValue());
					
					long tmValue = ((java.sql.Timestamp) ((oracle.sql.TIMESTAMP) item[2]).toJdbc()).getTime();
					Calendar cal = Calendar.getInstance();
					cal.setTimeInMillis(tmValue);
					co.setLogtime(cal.getTime());
					co.setUptime(cal.getTime());
					
					list.add(co);
				}
				return list;
			}
			else 
				return null;
		} catch (Exception ex) {
			logger.error("根据设备ID查询一氧化碳监测值异常", ex);
		} finally {
			try {
				DbUtils.commitAndClose(conn);
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		return null;
	}

	@Override
	public List<PgCO> findPblzByDeviceAndTm(Integer deviceid, String start, String end) {
		Connection conn = null;
		
		String queryStr = "SELECT ID, CO, LOGTIME, PGDEVICEID FROM PG_CO WHERE PGDEVICEID = ? AND LOGTIME >= TO_DATE(?, 'YYYY-MM-DD HH24:MI:SS') AND LOGTIME <= TO_DATE(?, 'YYYY-MM-DD HH24:MI:SS')";
		Object[] params = new Object[3];
		params[0] = deviceid;
		params[1] = start;
		params[2] = end;
		try {
			conn = ConnectionManager.getConnectionFromC3P0();
			conn.setAutoCommit(false);
			
			QueryRunner runner = new QueryRunner();
			List<Object[]> tempList = (List<Object[]>) runner.query(conn, queryStr, new ArrayListHandler());
			
			if (null != tempList && tempList.isEmpty() == false) {
				logger.debug("根据设备ID和时间查询一氧化碳监测值成功[" + tempList.size() + "]");
				
				List<PgCO> list = new ArrayList<PgCO>();
				for (int i = 0; i < tempList.size(); i++) {
					PgCO co = new PgCO();
					Object[] item = tempList.get(i);
					
					co.setId(((Number) item[0]).intValue());
					co.setCo(Float.parseFloat((String) item[1]));
					co.setPgdeviceid(((Number) item[3]).intValue());
					
					long tmValue = ((java.sql.Timestamp) ((oracle.sql.TIMESTAMP) item[2]).toJdbc()).getTime();
					Calendar cal = Calendar.getInstance();
					cal.setTimeInMillis(tmValue);
					co.setLogtime(cal.getTime());
					co.setUptime(cal.getTime());
					
					list.add(co);
				}
				return list;
			}
			else 
				return null;
		} catch (Exception ex) {
			logger.error("根据设备ID和时间查询一氧化碳监测值异常", ex);
		} finally {
			try {
				DbUtils.commitAndClose(conn);
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		return null;
	}

	@Override
	public int addPblzRecord(PgCO ch4) {
		return addPblzRecord(ch4.getCo(), ch4.getTmStr(), ch4.getPgdeviceid());
	}

	@Override
	public int addPblzRecord(float value, String tm, int deviceid) {
		Connection conn = null;
		
		String insertStr = "INSERT INTO PG_CO " + 
						   "(CO, LOGTIME, UPTIME, PGDEVICEID) " + 
						   "VALUES (?, TO_DATE(?, 'YYYY-MM-DD HH24:MI:SS'), TO_DATE(?, 'YYYY-MM-DD HH24:MI:SS'), ?)";
		Object[] params = new Object[4];
		params[0] = NumberFormat.format(value, "0.00");
		params[1] = tm;
		params[2] = tm;
		params[3] = deviceid;
		
		try {
			conn = ConnectionManager.getConnectionFromC3P0();
			conn.setAutoCommit(false);
			
			QueryRunner runner = new QueryRunner();
			int count = runner.update(conn, insertStr, params);
			
			if (count > 0) 
				logger.debug("插入一氧化碳监测值成功[tm=" + tm + ", value=" + value + ", deviceid=" + deviceid + "]");
			else 
				logger.error("插入一氧化碳监测值失败！");
			
			return count;
		} catch (Exception ex) {
			logger.error("插入一氧化碳监测值异常", ex);
		} finally {
			try {
				DbUtils.commitAndClose(conn);
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		return 0;
	}

	@Override
	public List<PgCOAlm> findAllSbjz() {
		Connection conn = null;
		
		String queryStr = "SELECT ID, COALM, LOGTIME, PGDEVICEID FROM PG_CO_ALM";
		try {
			conn = ConnectionManager.getConnectionFromC3P0();
			conn.setAutoCommit(false);
			
			QueryRunner runner = new QueryRunner();
			List<Object[]> tempList = (List<Object[]>) runner.query(conn, queryStr, new ArrayListHandler());
			
			if (null != tempList && tempList.isEmpty() == false) {
				logger.debug("查询所有一氧化碳报警状态成功[" + tempList.size() + "]");
				
				List<PgCOAlm> list = new ArrayList<PgCOAlm>();
				for (int i = 0; i < tempList.size(); i++) {
					PgCOAlm coalm = new PgCOAlm();
					Object[] item = tempList.get(i);
					
					coalm.setId(((Number) item[0]).intValue());
					coalm.setCoalm(Boolean.parseBoolean((String) item[1]));
					coalm.setPgdeviceid(((Number) item[3]).intValue());
					
					long tmValue = ((java.sql.Timestamp) ((oracle.sql.TIMESTAMP) item[2]).toJdbc()).getTime();
					Calendar cal = Calendar.getInstance();
					cal.setTimeInMillis(tmValue);
					coalm.setLogtime(cal.getTime());
					coalm.setUptime(cal.getTime());
					
					list.add(coalm);
				}
				return list;
			}
			else 
				return null;
		} catch (Exception ex) {
			logger.error("查询所有一氧化碳报警状态异常", ex);
		} finally {
			try {
				DbUtils.commitAndClose(conn);
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		return null;
	}

	@Override
	public PgCOAlm findSbjzById(Integer id) {
		Connection conn = null;
		
		String queryStr = "SELECT ID, COALM, LOGTIME, PGDEVICEID FROM PG_CO_ALM WHERE ID = ?";
		Object[] param = new Object[1];
		param[0] = id;
		try {
			conn = ConnectionManager.getConnectionFromC3P0();
			conn.setAutoCommit(false);
			
			QueryRunner runner = new QueryRunner();
			List<Object[]> tempList = (List<Object[]>) runner.query(conn, queryStr, new ArrayListHandler(), param);
			
			if (null != tempList && tempList.size() == 1) {
				PgCOAlm coalm = new PgCOAlm();
				Object[] item = tempList.get(0);
				
				coalm.setId(((Number) item[0]).intValue());
				coalm.setCoalm(Boolean.parseBoolean((String) item[1]));
				coalm.setPgdeviceid(((Number) item[3]).intValue());
				
				long tmValue = ((java.sql.Timestamp) ((oracle.sql.TIMESTAMP) item[2]).toJdbc()).getTime();
				Calendar cal = Calendar.getInstance();
				cal.setTimeInMillis(tmValue);
				coalm.setLogtime(cal.getTime());
				coalm.setUptime(cal.getTime());
				
				logger.debug("根据ID查询一氧化碳报警状态成功" + coalm + "]");
				
				return coalm;
			}
			else 
				return null;
		} catch (Exception ex) {
			logger.error("根据ID查询一氧化碳报警状态异常", ex);
		} finally {
			try {
				DbUtils.commitAndClose(conn);
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		return null;
	}

	@Override
	public List<PgCOAlm> findSbjzByDevice(Integer deviceid) {
		Connection conn = null;
		
		String queryStr = "SELECT ID, COALM, LOGTIME, PGDEVICEID FROM PG_CO_ALM WHERE PGDEVICEID = ?";
		Object[] param = new Object[1];
		param[0] = deviceid;
		try {
			conn = ConnectionManager.getConnectionFromC3P0();
			conn.setAutoCommit(false);
			
			QueryRunner runner = new QueryRunner();
			List<Object[]> tempList = (List<Object[]>) runner.query(conn, queryStr, new ArrayListHandler());
			
			if (null != tempList && tempList.isEmpty() == false) {
				logger.debug("根据设备ID查询一氧化碳报警状态成功[" + tempList.size() + "]");
				
				List<PgCOAlm> list = new ArrayList<PgCOAlm>();
				for (int i = 0; i < tempList.size(); i++) {
					PgCOAlm coalm = new PgCOAlm();
					Object[] item = tempList.get(i);
					
					coalm.setId(((Number) item[0]).intValue());
					coalm.setCoalm(Boolean.parseBoolean((String) item[1]));
					coalm.setPgdeviceid(((Number) item[3]).intValue());
					
					long tmValue = ((java.sql.Timestamp) ((oracle.sql.TIMESTAMP) item[2]).toJdbc()).getTime();
					Calendar cal = Calendar.getInstance();
					cal.setTimeInMillis(tmValue);
					coalm.setLogtime(cal.getTime());
					coalm.setUptime(cal.getTime());
					
					list.add(coalm);
				}
				return list;
			}
			else 
				return null;
		} catch (Exception ex) {
			logger.error("根据设备ID查询一氧化碳报警状态异常", ex);
		} finally {
			try {
				DbUtils.commitAndClose(conn);
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		return null;
	}

	@Override
	public List<PgCOAlm> findSbjzByDeviceAndTm(Integer deviceid, String start, String end) {
		Connection conn = null;
		
		String queryStr = "SELECT ID, COALM, LOGTIME, PGDEVICEID FROM PG_CO_ALM WHERE PGDEVICEID = ? AND LOGTIME >= TO_DATE(?, 'YYYY-MM-DD HH24:MI:SS') AND LOGTIME <= TO_DATE(?, 'YYYY-MM-DD HH24:MI:SS')";
		Object[] params = new Object[3];
		params[0] = deviceid;
		params[1] = start;
		params[2] = end;
		try {
			conn = ConnectionManager.getConnectionFromC3P0();
			conn.setAutoCommit(false);
			
			QueryRunner runner = new QueryRunner();
			List<Object[]> tempList = (List<Object[]>) runner.query(conn, queryStr, new ArrayListHandler());
			
			if (null != tempList && tempList.isEmpty() == false) {
				logger.debug("根据设备ID和时间查询一氧化碳报警状态成功[" + tempList.size() + "]");
				
				List<PgCOAlm> list = new ArrayList<PgCOAlm>();
				for (int i = 0; i < tempList.size(); i++) {
					PgCOAlm coalm = new PgCOAlm();
					Object[] item = tempList.get(i);
					
					coalm.setId(((Number) item[0]).intValue());
					coalm.setCoalm(Boolean.parseBoolean((String) item[1]));
					coalm.setPgdeviceid(((Number) item[3]).intValue());
					
					long tmValue = ((java.sql.Timestamp) ((oracle.sql.TIMESTAMP) item[2]).toJdbc()).getTime();
					Calendar cal = Calendar.getInstance();
					cal.setTimeInMillis(tmValue);
					coalm.setLogtime(cal.getTime());
					coalm.setUptime(cal.getTime());
					
					list.add(coalm);
				}
				return list;
			}
			else 
				return null;
		} catch (Exception ex) {
			logger.error("根据设备ID和时间查询一氧化碳报警状态异常", ex);
		} finally {
			try {
				DbUtils.commitAndClose(conn);
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		return null;
	}

	@Override
	public int addSbjzRecord(PgCOAlm ch4alm) {
		return addSbjzRecord(ch4alm.getCoalm(), ch4alm.getTmStr(), ch4alm.getPgdeviceid());
	}

	@Override
	public int addSbjzRecord(boolean status, String tm, int deviceid) {
		Connection conn = null;
		
		String insertStr = "INSERT INTO PG_CO_ALM " + 
						   "(COALM, LOGTIME, UPTIME, PGDEVICEID) " + 
						   "VALUES (?, TO_DATE(?, 'YYYY-MM-DD HH24:MI:SS'), TO_DATE(?, 'YYYY-MM-DD HH24:MI:SS'), ?)";
		Object[] params = new Object[4];
		params[0] = status;
		params[1] = tm;
		params[2] = tm;
		params[3] = deviceid;
		
		try {
			conn = ConnectionManager.getConnectionFromC3P0();
			conn.setAutoCommit(false);
			
			QueryRunner runner = new QueryRunner();
			int count = runner.update(conn, insertStr, params);
			
			if (count > 0) 
				logger.debug("插入一氧化碳报警状态成功[tm=" + tm + ", status=" + status + ", deviceid=" + deviceid + "]");
			else 
				logger.error("插入一氧化碳报警状态失败！");
			
			return count;
		} catch (Exception ex) {
			logger.error("插入一氧化碳报警状态异常", ex);
		} finally {
			try {
				DbUtils.commitAndClose(conn);
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		return 0;
	}

}
